import numpy as np
import pylab
import matplotlib.pyplot as plt
from life_game import LifeGame
from life_game_animation import LifeGameAnimation
from matplotlib.widgets import Button
import sys

sys.setrecursionlimit(10000)    # たくさんの再帰を行うためのおまじない

level = 2

G = np.zeros([4, 5], dtype='int8')
LG = LifeGame(G, level)
# print(LG.universe)
matrix = LG.universe


def trans(matrix):
    row, col = matrix.shape
    tmp = np.zeros([row, col])
    for i in range(row):
        for j in range(col):
            tmp[i, j] = matrix[row - i - 1, j]
    return tmp


def onclick(event):
    print(
        'event.button=%d,  event.x=%d, event.y=%d, event.xdata=%f, event.ydata=%f'
        % (event.button, event.x, event.y, event.xdata, event.ydata))
    if event.y > 105:
        if event.button == 1:
            matrix[LG.univrow - int(event.ydata) - 1, int(event.xdata)] = 1
        elif event.button == 3:
            matrix[LG.univrow - int(event.ydata) - 1, int(event.xdata)] = 0
        # print(matrix)
        ax.pcolormesh(trans(matrix), cmap='Greys')
        plt.show()


fig = plt.figure(figsize=(6, 3), dpi=282)
ax = plt.axes([0.075, 0.125, 0.85, 0.85])
ax.set_aspect('equal', 'datalim')
C = 10 * 2**(level - 1)
ax.set_xlim(0, 2 * C)
ax.set_ylim(0, C)
ax.xaxis.set_minor_locator(plt.MultipleLocator(1))
ax.yaxis.set_minor_locator(plt.MultipleLocator(1))
width = 2 / level
ax.grid(which='minor', axis='x', linewidth=width, linestyle='-', color='0.8')
ax.grid(which='minor', axis='y', linewidth=width, linestyle='-', color='0.8')
ax.tick_params(labelbottom="off", bottom="off")    # x軸の削除
ax.tick_params(labelleft="off", left="off")    # y軸の削除
ax.set_xticklabels([])
ax.set_yticklabels([])

cid = fig.canvas.mpl_connect('button_press_event', onclick)


def enter(event):
    # print('enter!')
    # print(matrix)
    LGA = LifeGameAnimation(matrix, level, 280)
    LGA.animation()
    plt.show()


axenter = plt.axes([0.81, 0.05, 0.1, 0.075])
benter = Button(axenter, 'Enter')
benter.on_clicked(enter)

plt.show()
